package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.RespDTO;
import com.diagbot.dto.data.AHomeDiagnoseDTO;
import com.diagbot.entity.HomeDiagnoseInfo;
import com.diagbot.service.impl.HomeDiagnoseInfoServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.TZDBConn;
import com.diagbot.vo.data.AHomeDiagnoseVO;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Component
public class AHomeDiagnoseInfoFacade {
    @Autowired
    @Qualifier("homeDiagnoseInfoServiceImpl")
    private HomeDiagnoseInfoServiceImpl homeDiagnoseInfoServiceImpl;

    private TZDBConn tzDBConn = new TZDBConn();

    /**
     * 终末质控-定时同步病案首页诊断
     */
    public void executeHomeDiagnose() {
        //String sql="select * from br_recdiagnose where BASYID in (select BASYID from br_rechome where cjcxrq>=dateadd(day,-2,getdate()) and cjcxrq<=getdate())";//今年的数据
        //前一天的数据
        String sql="select * from br_recdiagnose where BASYID in (select BASYID from br_rechome where cjcxrq>=(select CONVERT(varchar,GETDATE()-1,23)) and cjcxrq<(select CONVERT(varchar,GETDATE(),23)))";
        List<HomeDiagnoseInfo> homeDiagnoseList = tzDBConn.getHomeDiagnose(sql);
        execute(homeDiagnoseList);
    }

    public void executeHomeDiagnosePast() {
        String sql="select * from br_recdiagnose where BASYID in (select BASYID from br_rechome where cjcxrq>=dateadd(day,-2,getdate()) and cjcxrq<=getdate())";//今年的数据
        List<HomeDiagnoseInfo> homeDiagnoseList = tzDBConn.getHomeDiagnose(sql);
        execute(homeDiagnoseList);
    }

    public void executeHomeDiagnosePort(){

    }

    /**
     * 数据引擎-通过接口更新病案首页诊断
     * @param list
     * @return
     */
    public RespDTO<List<AHomeDiagnoseDTO>> executeHomeDiagnose(List<AHomeDiagnoseVO> list) {
        if(list!=null && list.size()>0){
            List<HomeDiagnoseInfo> homeDiagnoseList=Lists.newArrayList();
            List<AHomeDiagnoseDTO> homeDiagnoseDtoList=Lists.newArrayList();

            homeDiagnoseList=BeanUtil.listCopyTo(list,HomeDiagnoseInfo.class);
            homeDiagnoseDtoList=BeanUtil.listCopyTo(list,AHomeDiagnoseDTO.class);
            execute(homeDiagnoseList);
            return RespDTO.onSuc(homeDiagnoseDtoList);
        }else{
            return RespDTO.onError("未接收到数据!");
        }
    }

    public void execute(List<HomeDiagnoseInfo> homeDiagnoseList){
        if (homeDiagnoseList != null && homeDiagnoseList.size() > 0) {
            homeDiagnoseList.stream().forEach(s -> {
                if(s.getHomePageId()!=null && !"".equals(s.getDiagnoseOrderNo())){
                    QueryWrapper<HomeDiagnoseInfo> queryWrapper = new QueryWrapper<>();
                    queryWrapper.eq("home_page_id", s.getHomePageId());
                    queryWrapper.eq("hospital_id", s.getHospitalId());
                    queryWrapper.eq("diagnose_order_no", s.getDiagnoseOrderNo());
                    HomeDiagnoseInfo diagnoseInfo = homeDiagnoseInfoServiceImpl.getOne(queryWrapper);
                    if (diagnoseInfo != null) {
                        s.setGmtModified(new Date());
                        homeDiagnoseInfoServiceImpl.update(s,queryWrapper);
                    } else {
                        s.setGmtCreate(new Date());
                        homeDiagnoseInfoServiceImpl.save(s);
                    }
                }
            });
        }
    }
}
