package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.data.AHomeOperationDTO;
import com.diagbot.entity.HomeOperationInfo;
import com.diagbot.service.impl.HomeOperationInfoServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.TZDBConn;
import com.diagbot.vo.data.AHomeOperationVO;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Component
public class AHomeOperationInfoFacade {
    @Autowired
    @Qualifier("homeOperationInfoServiceImpl")
    private HomeOperationInfoServiceImpl homeOperationInfoServiceImpl;

    private TZDBConn tzDBConn = new TZDBConn();

    /**
     * 终末质控-同步前一天数据
     */
    public void executeHomeOperation() {
        //String sql="select * from br_recoperation where cjcxrq>=dateadd(day,-2,getdate()) and cjcxrq<=getdate()";
        //前一天数据
        String sql="select * from br_recoperation where cjcxrq>=(select CONVERT(varchar,GETDATE()-1,23)) and cjcxrq<(select CONVERT(varchar,GETDATE(),23))";
        List<HomeOperationInfo> homeOperationList = tzDBConn.getHomeOperation(sql);
        execute(homeOperationList);
    }

    public void executeHomeOperationPast() {
        String sql="select * from br_recoperation where cjcxrq>=dateadd(day,-2,getdate()) and cjcxrq<=getdate()";
        List<HomeOperationInfo> homeOperationList = tzDBConn.getHomeOperation(sql);
        execute(homeOperationList);
    }

    public void executeHomeOperationPort(){

    }

    /**
     * 数据引擎-通过接口更新病案首页手术
     * @param list
     * @return
     */
    public List<AHomeOperationDTO> executeHomeOperation(List<AHomeOperationVO> list) {
        List<HomeOperationInfo> homeOperationList=Lists.newArrayList();
        List<AHomeOperationDTO> homeOperationDtoList=Lists.newArrayList();
        if(list!=null && list.size()>0){
            homeOperationList=BeanUtil.listCopyTo(list,HomeOperationInfo.class);
            homeOperationDtoList=BeanUtil.listCopyTo(list,AHomeOperationDTO.class);
            execute(homeOperationList);
        }
        return homeOperationDtoList;
    }

    public void execute(List<HomeOperationInfo> homeOperationList){
        if (homeOperationList != null && homeOperationList.size() > 0) {
            homeOperationList.stream().forEach(s -> {
                if(s.getHomePageId()!=null && !"".equals(s.getOperationOrderNo())) {
                    QueryWrapper<HomeOperationInfo> queryWrapper = new QueryWrapper<>();
                    queryWrapper.eq("home_page_id", s.getHomePageId());
                    queryWrapper.eq("hospital_id", s.getHospitalId());
                    queryWrapper.eq("operation_order_no", s.getOperationOrderNo());
                    HomeOperationInfo operationInfo = homeOperationInfoServiceImpl.getOne(queryWrapper);
                    if (operationInfo != null) {
                        s.setGmtModified(new Date());
                        homeOperationInfoServiceImpl.update(s,queryWrapper);
                    } else {
                        s.setGmtCreate(new Date());
                        homeOperationInfoServiceImpl.save(s);
                    }
                }
            });
        }
    }
}
