package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.RespDTO;
import com.diagbot.dto.data.AHomeDiagnoseDTO;
import com.diagbot.dto.data.AMedCrisisDTO;
import com.diagbot.entity.BehospitalInfo;
import com.diagbot.entity.HomeDiagnoseInfo;
import com.diagbot.entity.MedCrisisInfo;
import com.diagbot.service.impl.MedCrisisInfoServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.vo.data.AMedCrisisVO;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Component
public class AMedCrisisFacade {

    @Autowired
    @Qualifier("medCrisisInfoServiceImpl")
    private MedCrisisInfoServiceImpl medCrisisInfoServiceImpl;

    public void executeMedCrisis(){

    }

    public RespDTO<List<AMedCrisisDTO>> executeMedCrisis(List<AMedCrisisVO> list) {
        if(list!=null && list.size()>0){
            //循环验证数据有效性
            for (AMedCrisisVO aMedCrisisVO:list) {
                if("".equals(aMedCrisisVO.getRecId())){
                    return RespDTO.onError("请输入文书编码!");
                }else if("".equals(aMedCrisisVO.getBehospitalCode())) {
                    return RespDTO.onError("请输入病人住院编码!");
                }else if(aMedCrisisVO.getHospitalId()==null){
                    return RespDTO.onError("请输入医院编码!");
                }else if("".equals(aMedCrisisVO.getRecType())){
                    return RespDTO.onError("请输入危急值类型!");
                }
            }

            List<MedCrisisInfo> medCrisisList=Lists.newArrayList();
            List<AMedCrisisDTO> medCrisisDtoList=Lists.newArrayList();

            medCrisisList=BeanUtil.listCopyTo(list,MedCrisisInfo.class);
            medCrisisDtoList=BeanUtil.listCopyTo(list,AMedCrisisDTO.class);
            execute(medCrisisList);
            return RespDTO.onSuc(medCrisisDtoList);
        }else{
            return RespDTO.onError("未接收到数据!");
        }
    }

    public void execute(List<MedCrisisInfo> medCrisisList){
        if (medCrisisList != null && medCrisisList.size() > 0) {
            medCrisisList.stream().forEach(s -> {
                QueryWrapper<MedCrisisInfo> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("rec_id", s.getRecId());
                queryWrapper.eq("hospital_id", s.getHospitalId());
                queryWrapper.eq("behospital_code", s.getBehospitalCode());
                queryWrapper.eq("rec_type", s.getRecType());
                MedCrisisInfo medCrisisInfo = medCrisisInfoServiceImpl.getOne(queryWrapper);
                if (medCrisisInfo != null) {
                    s.setGmtModified(new Date());
                    medCrisisInfoServiceImpl.update(s,queryWrapper);
                } else {
                    s.setGmtCreate(new Date());
                    medCrisisInfoServiceImpl.save(s);
                }
            });
        }
    }
}
