package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.data.AMedicalRecordContentDTO;
import com.diagbot.entity.MedicalRecordContent;
import com.diagbot.service.impl.MedicalRecordContentServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.TZDBConn;
import com.diagbot.vo.data.AMedicalRecordContentVO;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.*;

@Component
public class AMedicalRecordContentFacade {
    @Autowired
    @Qualifier("medicalRecordContentServiceImpl")
    private MedicalRecordContentServiceImpl medicalRecordContentServiceImpl;

    private TZDBConn tzDBConn = new TZDBConn();

    /**
     * 终末质控-同步前一天的病历详细记录
     */
    public void executeMrRecordContent() {
        //String sql="select * from mr_mrcontent  where cjcxrq>=dateadd(day,-2,getdate()) and cjcxrq<=getdate()";
        String sql="select BLJLID,BLJLNR from mr_mrcontent  where cjcxrq>=(select CONVERT(varchar,GETDATE()-1,23)) and cjcxrq<(select CONVERT(varchar,GETDATE(),23)) ORDER BY cjcxrq DESC";
        List<MedicalRecordContent> mrContentList = tzDBConn.getMedicalRecordContent(sql);
        execute(mrContentList);
    }

    /**
     * 同步前一天的病历详细记录
     */
    public void executeMrRecordContentPast() {
        String sql="select * from mr_mrcontent  where cjcxrq>=dateadd(day,-2,getdate()) and cjcxrq<=getdate()";
        List<MedicalRecordContent> mrContentList = tzDBConn.getMedicalRecordContent(sql);
        execute(mrContentList);
    }

    public void executeMrRecordContentPort(){

    }

    /**
     * 数据引擎-通过接口更新病历内容
     * @param list
     * @return
     */
    public List<AMedicalRecordContentDTO> executeMrRecordContent(List<AMedicalRecordContentVO> list) {
        List<MedicalRecordContent> mrContentList=Lists.newArrayList();
        List<AMedicalRecordContentDTO> mrContentDtoList=Lists.newArrayList();
        if(list!=null && list.size()>0){
            mrContentList=BeanUtil.listCopyTo(list,MedicalRecordContent.class);
            mrContentDtoList=BeanUtil.listCopyTo(list,AMedicalRecordContentDTO.class);
            execute(mrContentList);
        }
        return mrContentDtoList;
    }

    public void execute(List<MedicalRecordContent> mrContentList){
        if (mrContentList != null && mrContentList.size() > 0) {
            mrContentList.stream().forEach(s -> {
                QueryWrapper<MedicalRecordContent> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("rec_id", s.getRecId());
                queryWrapper.eq("hospital_id", s.getHospitalId());
                MedicalRecordContent mrContent = medicalRecordContentServiceImpl.getOne(queryWrapper);
                if (mrContent != null) {
                    s.setGmtModified(new Date());
                    medicalRecordContentServiceImpl.updateById(s);
                } else {
                    s.setGmtCreate(new Date());
                    medicalRecordContentServiceImpl.save(s);
                }
            });
        }
    }
}
