package com.diagbot.facade;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class DataFacade {
    @Autowired
    private ABasDeptInfoFacade aBasDeptInfoFacade;

    @Autowired
    private ABasDoctorInfoFacade aBasDoctorInfoFacade;

    @Autowired
    private AHomePageFacade aHomePageFacade;

    @Autowired
    private AHomeDiagnoseInfoFacade aHomeDiagnoseInfoFacade;

    @Autowired
    private AHomeOperationInfoFacade aHomeOperationInfoFacade;

    @Autowired
    private AMedRecordTypeFacade aMedRecordTypeFacade;

    @Autowired
    private AMedicalRecordFacade aMedicalRecordFacade;

    @Autowired
    private AMedicalRecordContentFacade aMedicalRecordContentFacade;

    @Autowired
    private ABehospitalInfoFacade aBehospitalInfoFacade;

    @Autowired
    private ADoctorAdviceFacade aDoctorAdviceFacade;


    public void executeView(){
        aBasDeptInfoFacade.executeDeptPast();//科室信息

        aBasDoctorInfoFacade.executeDoctorPast();//医生信息

        aHomePageFacade.executeHomePagePast();//病案首页

        aHomeDiagnoseInfoFacade.executeHomeDiagnosePast();//病案首页诊断

        aHomeOperationInfoFacade.executeHomeOperationPast();//病案首页手术

        aMedRecordTypeFacade.executeMRTypePast();//模板类型

        aMedicalRecordFacade.executeMrRecordPast();//病历

        aMedicalRecordContentFacade.executeMrRecordContentPast();//病历内容

        aBehospitalInfoFacade.executeBehospitalPast();//住院信息

        aDoctorAdviceFacade.executeDoctorAdvicePast();//住院医嘱信息
    }


    public void executePort(){
        aBasDeptInfoFacade.executeDeptPort();//科室信息

        aBasDoctorInfoFacade.executeDoctorPort();//医生信息

        aHomePageFacade.executeHomePagePort();//病案首页

        aHomeDiagnoseInfoFacade.executeHomeDiagnosePort();//病案首页诊断

        aHomeOperationInfoFacade.executeHomeOperationPort();//病案首页手术

        aMedRecordTypeFacade.executeMRTypePort();//模板类型

        aMedicalRecordFacade.executeMrRecordPort();//病历

        aMedicalRecordContentFacade.executeMrRecordContentPort();//病历内容

        aBehospitalInfoFacade.executeBehospitalPort();//住院信息

        aDoctorAdviceFacade.executeDoctorAdvicePort();//住院医嘱信息
    }
}
